; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------------------

        Build this  template with
       "CONSOLE ASSEMBLE AND LINK"

        This example demonstrates how to pass multiple arguments to a new
        thread using a structure. It creates a structure on the stack of
        the calling thread then passes its address to the new thread as a
        means of passing multiple argumrents in a single DWORD parameter.

        A global flag is used in this example so that the calling thread
        does not exit until the arguments passed to the new thread have
        been copied to local variable in the new thread procedure.

        ----------------------------------------------------------------- *

    worker_thread PROTO :DWORD

    tblock STRUCT
      item1 dd ?
      item2 dd ?
      item3 dd ?
      item4 dd ?
    tblock ENDS

    .data
      thread_flag dd 0

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL tID       :DWORD
    LOCAL hThread   :DWORD
    LOCAL blk       :tblock ; a stack based structure

    mov blk.item1, 1111     ; write data to structure members
    mov blk.item2, 2222
    mov blk.item3, 3333
    mov blk.item4, 4444

  ; ------------------------------------
  ; display the data from the caller end.
  ; ------------------------------------
    print str$(blk.item1)," caller here",13,10
    print str$(blk.item2)," caller here",13,10
    print str$(blk.item3)," caller here",13,10
    print str$(blk.item4)," caller here",13,10

    print "----------------",13,10

  ; -------------------
  ; create a new thread.
  ; -------------------

    mov thread_flag, 1     ; set a global flag

    fn CreateThread,0,0,ADDR worker_thread,ADDR blk,0,ADDR tID
    mov hThread, eax

  ; --------------------------------------------
  ; loop until new thread clears the global flag
  ; --------------------------------------------
  @@:
    invoke SleepEx,1,0
    cmp thread_flag, 0
    jne @B

    invoke CloseHandle,hThread

    ret

main endp

; 

worker_thread proc pstruct:DWORD

    LOCAL arg1  :DWORD
    LOCAL arg2  :DWORD
    LOCAL arg3  :DWORD
    LOCAL arg4  :DWORD

  ; ----------------------------------------
  ; manually pick apart the passed structure
  ; and write its members to local variables
  ; ----------------------------------------
    mov eax, pstruct        ; load struct address in EAX
    mov ecx, [eax]
    mov arg1, ecx
    mov ecx, [eax+4]
    mov arg2, ecx
    mov ecx, [eax+8]
    mov arg3, ecx
    mov ecx, [eax+12]
    mov arg4, ecx

  ; ----------------------------------------------
  ; once arguments are written to local variables,
  ; clear the global flag to re-enable the calling
  ; thread
  ; ----------------------------------------------
    mov thread_flag, 0

  ; ----------------------------
  ; display the passed arguments
  ; ----------------------------
    print str$(arg1)," thread here",13,10
    print str$(arg2)," thread here",13,10
    print str$(arg3)," thread here",13,10
    print str$(arg4)," thread here",13,10

    ret

worker_thread endp

; 

end start
